unit sphinx_ad;

{$mode objfpc}{$H+}

interface

uses
 SysUtils;

type
  TpsAudioDevice = record
   sps, bps: int32;
		end;

  PpsAudioDevice = ^TpsAudioDevice;

  PadBuffer = ^int16;

const
  SAD_lib_name = 'libsphinxad.so.3';

  // results
  AD_OK = 0;
  AD_EOF = -1;
  AD_ERR_GEN = -1;
  AD_ERR_NOT_OPEN = -2;
  AD_ERR_WAVE = -3;


// functions

function ad_open: PpsAudioDevice; cdecl; external SAD_lib_name name 'ad_open';
function ad_open_sps(sampleRate: int32): PpsAudioDevice; cdecl; external SAD_lib_name name 'ad_open_sps';
function ad_open_dev(const name: PChar; sampleRate: int32): PpsAudioDevice; cdecl; external SAD_lib_name name 'ad_open_dev';
function ad_start_rec(dev: PpsAudioDevice): int32; cdecl; external SAD_lib_name name 'ad_start_rec';
function ad_stop_rec(dev: PpsAudioDevice): int32; cdecl; external SAD_lib_name name 'ad_stop_rec';
function ad_close(dev: PpsAudioDevice): int32; cdecl; external SAD_lib_name name 'ad_close';
function ad_read(dev: PpsAudioDevice; buffer: PadBuffer; maxSize: int32): int32; cdecl; external SAD_lib_name name 'ad_read';


implementation

end.

